/*
 * Copyright (c) 2000,2012 CNRS/LAAS
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _GYRO_PRIVATE_H
#define _GYRO_PRIVATE_H

struct GYRO_DATA {
	double earthSpeed;	/* approximate earth rotation speed at
				   initial latitude */
	double w;		/* angular rate */
	double wOffset;		/* angular rate offset */
	double theta;		/* integrated angle */
	int wsign;		/* rotation sign */
	uint32_t date;		/* date of acquisition */
	uint32_t prevDate;	/* date of previous acquisition */
	uint32_t period;	/* duration from previous acquistion */
	int nbMeasuresOffset;	/* number of measures to calibrate offset */
	BOOL (*close)(struct GYRO_DATA *); /* close function */
};

uint32_t getTime(void);
double gyroEarthSpeed(double);
void gyroIntegrate(struct GYRO_DATA *, double);

#endif /* _GYRO_PRIVATE_H */
